<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>Nodejs-demo-NestJs-and-BDD documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	   <link rel="stylesheet" href="../styles/style.css">
        <link rel="stylesheet" href="../styles/dark.css">
        <link rel="stylesheet" href="../styles/postmark.css">
    </head>
    <body>
          <script>
               // Blocking script to avaoid flickering dark mode
               // Dark mode toggle button
               var useDark = window.matchMedia('(prefers-color-scheme: dark)');
               var darkModeState = useDark.matches;
               var $darkModeToggleSwitchers = document.querySelectorAll('.dark-mode-switch input');
               var $darkModeToggles = document.querySelectorAll('.dark-mode-switch');
               var darkModeStateLocal = localStorage.getItem('compodoc_darkmode-state');

               function checkToggle(check) {
                    for (var i = 0; i < $darkModeToggleSwitchers.length; i++) {
                         $darkModeToggleSwitchers[i].checked = check;
                    }
               }

               function toggleDarkMode(state) {
                    if (window.localStorage) {
                         localStorage.setItem('compodoc_darkmode-state', state);
                    }

                    checkToggle(state);

                    const hasClass = document.body.classList.contains('dark');

                    if (state) {
                         for (var i = 0; i < $darkModeToggles.length; i++) {
                              $darkModeToggles[i].classList.add('dark');
                         }
                         if (!hasClass) {
                              document.body.classList.add('dark');
                         }
                    } else {
                         for (var i = 0; i < $darkModeToggles.length; i++) {
                              $darkModeToggles[i].classList.remove('dark');
                         }
                         if (hasClass) {
                              document.body.classList.remove('dark');
                         }
                    }
               }

               useDark.addEventListener('change', function (evt) {
                    toggleDarkMode(evt.matches);
               });
               if (darkModeStateLocal) {
                    darkModeState = darkModeStateLocal === 'true';
               }
               toggleDarkMode(darkModeState);

               if ($darkModeToggles.length > 0) {
                    for (var i = 0; i < $darkModeToggleSwitchers.length; i++) {
                         $darkModeToggleSwitchers[i].addEventListener('change', function (event) {
                              darkModeState = !darkModeState;
                              toggleDarkMode(darkModeState);
                         });
                    }
               }
          </script>

        <div class="navbar navbar-default navbar-fixed-top d-block d-sm-none">
            <a href="../" class="navbar-brand">Nodejs-demo-NestJs-and-BDD documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content controller">
                   <div class="content-data">





<ol class="breadcrumb">
  <li class="breadcrumb-item">Controllers</li>
  <li class="breadcrumb-item" >FakeBackApiController</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="nav-item">
            <a href="#info" 
                class="nav-link"
                class="nav-link active"
                role="tab" id="info-tab" data-bs-toggle="tab" data-link="info">Info</a>
        </li>
        <li class="nav-item">
            <a href="#source" 
                class="nav-link"
                
                role="tab" id="source-tab" data-bs-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/fake-third-app/fake-back-api.controller.ts</code>
        </p>

            <p class="comment">
                <h3>Prefix</h3>
            </p>
            <p class="comment">
                <code>units</code>
            </p>






            <section data-compodoc="block-index">
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier"></span>
                                    <span class="modifier">Async</span>
                                <a href="#createUnit" >createUnit</a>
                            </li>
                            <li>
                                    <span class="modifier"></span>
                                    <span class="modifier">Async</span>
                                <a href="#deleteUnit" >deleteUnit</a>
                            </li>
                            <li>
                                    <span class="modifier"></span>
                                    <span class="modifier">Async</span>
                                <a href="#getUnitById" >getUnitById</a>
                            </li>
                            <li>
                                    <span class="modifier"></span>
                                    <span class="modifier">Async</span>
                                <a href="#getUnits" >getUnits</a>
                            </li>
                            <li>
                                    <span class="modifier"></span>
                                    <span class="modifier">Async</span>
                                <a href="#updatePutUnit" >updatePutUnit</a>
                            </li>
                            <li>
                                    <span class="modifier"></span>
                                    <span class="modifier">Async</span>
                                <a href="#updateUnit" >updateUnit</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section data-compodoc="block-methods">
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="createUnit"></a>
                    <span class="name">
                            <span class="modifier"></span>
                            <span class="modifier">Async</span>
                        <span ><b>createUnit</b></span>
                        <a href="#createUnit"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>createUnit(res, createUnitEntity: <a href="../classes/UnitEntity.html" target="_self">UnitEntity</a>)</code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Decorators : </b>
                    <br />
                    <code>@Post()<br /></code>
                </td>
            </tr>

                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="88"
                                    class="link-to-prism">src/fake-third-app/fake-back-api.controller.ts:88</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                                <td>Type</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>res</td>
                                            <td>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                        <tr>
                                                <td>createUnitEntity</td>
                                            <td>
                                                            <code><a href="../classes/UnitEntity.html" target="_self" >UnitEntity</a></code>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>    <code>unknown</code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="deleteUnit"></a>
                    <span class="name">
                            <span class="modifier"></span>
                            <span class="modifier">Async</span>
                        <span ><b>deleteUnit</b></span>
                        <a href="#deleteUnit"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>deleteUnit(res, unitId: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Decorators : </b>
                    <br />
                    <code>@Delete(&#x27;/:id&#x27;)<br /></code>
                </td>
            </tr>

                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="171"
                                    class="link-to-prism">src/fake-third-app/fake-back-api.controller.ts:171</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                                <td>Type</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>res</td>
                                            <td>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                        <tr>
                                                <td>unitId</td>
                                            <td>
                                                            <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>    <code>unknown</code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getUnitById"></a>
                    <span class="name">
                            <span class="modifier"></span>
                            <span class="modifier">Async</span>
                        <span ><b>getUnitById</b></span>
                        <a href="#getUnitById"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>getUnitById(res, unitId: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Decorators : </b>
                    <br />
                    <code>@Get(&#x27;/:id&#x27;)<br /></code>
                </td>
            </tr>

                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="62"
                                    class="link-to-prism">src/fake-third-app/fake-back-api.controller.ts:62</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                                <td>Type</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>res</td>
                                            <td>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                        <tr>
                                                <td>unitId</td>
                                            <td>
                                                            <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>    <code>unknown</code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getUnits"></a>
                    <span class="name">
                            <span class="modifier"></span>
                            <span class="modifier">Async</span>
                        <span ><b>getUnits</b></span>
                        <a href="#getUnits"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>getUnits(res, paginationQuery: <a href="../classes/PaginationQueryDto.html" target="_self">PaginationQueryDto</a>)</code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Decorators : </b>
                    <br />
                    <code>@Get()<br /></code>
                </td>
            </tr>

                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="43"
                                    class="link-to-prism">src/fake-third-app/fake-back-api.controller.ts:43</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                                <td>Type</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>res</td>
                                            <td>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                        <tr>
                                                <td>paginationQuery</td>
                                            <td>
                                                            <code><a href="../classes/PaginationQueryDto.html" target="_self" >PaginationQueryDto</a></code>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>    <code>unknown</code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="updatePutUnit"></a>
                    <span class="name">
                            <span class="modifier"></span>
                            <span class="modifier">Async</span>
                        <span ><b>updatePutUnit</b></span>
                        <a href="#updatePutUnit"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>updatePutUnit(res, unitId: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, updateUnitEntity: <a href="../classes/UnitEntity.html" target="_self">UnitEntity</a>)</code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Decorators : </b>
                    <br />
                    <code>@Put(&#x27;/:id&#x27;)<br /></code>
                </td>
            </tr>

                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="142"
                                    class="link-to-prism">src/fake-third-app/fake-back-api.controller.ts:142</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                                <td>Type</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>res</td>
                                            <td>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                        <tr>
                                                <td>unitId</td>
                                            <td>
                                                            <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                        <tr>
                                                <td>updateUnitEntity</td>
                                            <td>
                                                            <code><a href="../classes/UnitEntity.html" target="_self" >UnitEntity</a></code>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>    <code>unknown</code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="updateUnit"></a>
                    <span class="name">
                            <span class="modifier"></span>
                            <span class="modifier">Async</span>
                        <span ><b>updateUnit</b></span>
                        <a href="#updateUnit"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>updateUnit(res, unitId: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, updateUnitEntity: <a href="../classes/UnitEntity.html" target="_self">UnitEntity</a>)</code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Decorators : </b>
                    <br />
                    <code>@Patch(&#x27;/:id&#x27;)<br /></code>
                </td>
            </tr>

                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="111"
                                    class="link-to-prism">src/fake-third-app/fake-back-api.controller.ts:111</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                                <td>Type</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>res</td>
                                            <td>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                        <tr>
                                                <td>unitId</td>
                                            <td>
                                                            <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                        <tr>
                                                <td>updateUnitEntity</td>
                                            <td>
                                                            <code><a href="../classes/UnitEntity.html" target="_self" >UnitEntity</a></code>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>    <code>unknown</code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>    </div>


    <div class="tab-pane fade  tab-source-code" id="source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import {
  Body,
  Controller,
  Delete,
  Get,
  HttpStatus,
  Inject,
  Injectable,
  NotFoundException,
  Param,
  Patch,
  Post,
  Put,
  Query,
  Req,
  Res,
} from &#x27;@nestjs/common&#x27;;
import { lastValueFrom } from &#x27;rxjs&#x27;;
import { ApiProperty, ApiTags } from &#x27;@nestjs/swagger&#x27;;
import { FakeBackApiService } from &#x27;./services/fake-back-api.service&#x27;;
import { join } from &#x27;path&#x27;;
import { Response, NextFunction, Request } from &#x27;express&#x27;;
import { WINSTON_MODULE_PROVIDER } from &#x27;nest-winston&#x27;;
import { Logger } from &#x27;winston&#x27;;
import { UnitEntity } from &#x27;./entities/unit.entity&#x27;;
import { PaginationQueryDto } from &#x27;./dto/pagination-query.dto&#x27;;

@ApiTags(&#x27;backend fake third app&#x27;)
@Controller(&#x27;units&#x27;)
export class FakeBackApiController {
  errorContext: string;
  constructor(
    @Inject(WINSTON_MODULE_PROVIDER) private readonly logger: Logger,
    private readonly fakeBackApiService: FakeBackApiService,
  ) {
    this.errorContext &#x3D; &#x27;FakeThirdAppModule.FakeBackApiController&#x27;;
    // Reset sample data on restart session
    this.fakeBackApiService.resetAllUnits();
  }

  // QUERY
  @Get()
  async getUnits(@Res() res, @Query() paginationQuery: PaginationQueryDto) {
    try {
      this.logger.debug(&#x60;${this.errorContext}.getUnits().begun&#x60;);
      const units &#x3D; await lastValueFrom(
        this.fakeBackApiService.getUnits(paginationQuery),
      );
      return res.status(HttpStatus.OK).json(units);
    } catch (err) {
      const errorMessage &#x3D; &#x60;${this.errorContext}.getUnits().failed: ${err.message}&#x60;;
      this.logger.error(errorMessage);
      return res.status(HttpStatus.BAD_REQUEST).json({
        message: &#x60;Error: Units not listed! ${errorMessage}&#x60;,
        status: 500,
      });
    }
  }

  // READ
  @Get(&#x27;/:id&#x27;)
  async getUnitById(@Res() res, @Param(&#x27;id&#x27;) unitId: string) {
    try {
      this.logger.debug(&#x60;${this.errorContext}.getUnitById().begun&#x60;);
      if (!unitId) {
        throw new NotFoundException(&#x27;Param ID is required&#x27;);
      }
      const unit &#x3D; await lastValueFrom(
        this.fakeBackApiService.getUnitById(unitId),
      );
      if (!unit) {
        throw new NotFoundException(&#x27;Unit does not exist!&#x27;);
      }
      return res.status(HttpStatus.OK).json(unit);
    } catch (err) {
      const errorMessage &#x3D; &#x60;${this.errorContext}.getUnitById().failed: ${err.message}&#x60;;
      this.logger.error(errorMessage);
      return res.status(HttpStatus.BAD_REQUEST).json({
        message: &#x60;Error: Unit not read! ${errorMessage}&#x60;,
        status: 500,
      });
    }
  }

  // CREATE
  @Post()
  // @HttpCode(201) // already 201 by defaut for POST
  async createUnit(@Res() res, @Body() createUnitEntity: UnitEntity) {
    try {
      this.logger.debug(&#x60;${this.errorContext}.createUnit().begun&#x60;);
      if (!createUnitEntity) {
        throw new NotFoundException(&#x27;Param body is required&#x27;);
      }
      const unit &#x3D; await lastValueFrom(
        this.fakeBackApiService.createUnit(createUnitEntity),
      );
      return res.status(HttpStatus.CREATED).json(unit);
    } catch (err) {
      const errorMessage &#x3D; &#x60;${this.errorContext}.createUnit().failed: ${err.message}&#x60;;
      this.logger.error(errorMessage);
      return res.status(HttpStatus.BAD_REQUEST).json({
        message: &#x60;Error: Unit not created! ${errorMessage}&#x60;,
        status: 500,
      });
    }
  }

  // UPDATE
  // curl -X PATCH -H &quot;Content-type:application/json&quot; --data-binary &quot;{ \&quot;code\&quot;: \&quot;test\&quot;}&quot; http://localhost:3000/units/608da27a23ec6f382c27a644
  @Patch(&#x27;/:id&#x27;)
  async updateUnit(
    @Res() res,
    @Param(&#x27;id&#x27;) unitId: string,
    @Body() updateUnitEntity: UnitEntity,
  ) {
    try {
      this.logger.debug(&#x60;${this.errorContext}.updateUnit().begun&#x60;);
      if (!unitId) {
        throw new NotFoundException(&#x27;Param ID is required&#x27;);
      }
      if (!updateUnitEntity) {
        throw new NotFoundException(&#x27;Param body is required&#x27;);
      }
      const unit &#x3D; await lastValueFrom(
        this.fakeBackApiService.updateUnit(unitId, updateUnitEntity),
      );
      if (!unit) {
        throw new NotFoundException(&#x27;Unit does not exist!&#x27;);
      }
      return res.status(HttpStatus.OK).json(unit);
    } catch (err) {
      const errorMessage &#x3D; &#x60;${this.errorContext}.updateUnit().failed: ${err.message}&#x60;;
      this.logger.error(errorMessage);
      return res.status(HttpStatus.BAD_REQUEST).json({
        message: &#x60;Error: Unit not updated! ${errorMessage}&#x60;,
        status: 500,
      });
    }
  }

  @Put(&#x27;/:id&#x27;)
  async updatePutUnit(
    @Res() res,
    @Param(&#x27;id&#x27;) unitId: string,
    @Body() updateUnitEntity: UnitEntity,
  ) {
    try {
      this.logger.debug(&#x60;${this.errorContext}.updatePutUnit().begun&#x60;);
      if (!unitId) {
        throw new NotFoundException(&#x27;Param ID is required&#x27;);
      }
      const unit &#x3D; await lastValueFrom(
        this.fakeBackApiService.updateUnit(unitId, updateUnitEntity),
      );
      if (!unit) {
        throw new NotFoundException(&#x27;Unit does not exist!&#x27;);
      }
      return res.status(HttpStatus.OK).json(unit);
    } catch (err) {
      const errorMessage &#x3D; &#x60;${this.errorContext}.updatePutUnit().failed: ${err.message}&#x60;;
      this.logger.error(errorMessage);
      return res.status(HttpStatus.BAD_REQUEST).json({
        message: &#x60;Error: Unit not updated! ${errorMessage}&#x60;,
        status: 500,
      });
    }
  }

  // DELETE
  @Delete(&#x27;/:id&#x27;)
  async deleteUnit(@Res() res, @Param(&#x27;id&#x27;) unitId: string) {
    try {
      this.logger.debug(&#x60;${this.errorContext}.deleteUnit().begun&#x60;);
      if (!unitId) {
        throw new NotFoundException(&#x27;Unit ID does not exist&#x27;);
      }
      const unit &#x3D; lastValueFrom(this.fakeBackApiService.deleteUnit(unitId));
      if (!unit) {
        throw new NotFoundException(&#x27;Unit does not exist!&#x27;);
      }
      return res.status(HttpStatus.OK).json(unit);
    } catch (err) {
      const errorMessage &#x3D; &#x60;${this.errorContext}.deleteUnit().failed: ${err.message}&#x60;;
      this.logger.error(errorMessage);
      return res.status(HttpStatus.BAD_REQUEST).json({
        message: &#x60;Error: Unit not deleted! ${errorMessage}&#x60;,
        status: 500,
      });
    }
  }
}
</code></pre>
    </div>
</div>
















                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> results matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

          <label class="dark-mode-switch">
               <input type="checkbox">
               <span class="slider">
                    <svg class="slider-icon" viewBox="0 0 24 24" fill="none" height="20" stroke="#000" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" width="20" xmlns="http://www.w3.org/2000/svg">
                    <path d="M21 12.79A9 9 0 1111.21 3 7 7 0 0021 12.79z"></path>
                    </svg>
               </span>
          </label>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'controller';
            var COMPODOC_CURRENT_PAGE_URL = 'FakeBackApiController.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>

       <script src="../js/menu-wc.js" defer></script>
       <script nomodule src="../js/menu-wc_es5.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
